
open "inline_h";

val diversify_count = ref 0

fun diversify_name (usename, psig, pr) =
    let memofun newname P =
		if P inset pr
		    then let val f as |[put, convert, ...]| = outstring P
			     val P' = (put ":";
				       print f (pack (!diversify_count));
				       put "[";
				       put usename;
				       put "]";
				       convert ())
			     val ps = !psig
			 in
			     (psig := ps ++ {P' => ?ps P};
			      P')
			     handle MapGet => raise NoPredSig P
			 end
		else P
    in
	newname
    end;

fun diversify_clauses newname =
    let fun newatom (ATOM (P, l)) = ATOM (newname P, l)
    in
	fn pr => {newname P =>
		   [DCLAUSE (newname name, env, newatom h,
			     [newatom a | a in list body])
		   | DCLAUSE (name, env, h, body) in list dcls]
		 | P => dcls in map pr}
    end;

fun reachable_predicates (Ps, pr) =
    let val Psr = ref Ps
	val workset = ref Ps
    in
	while not (empty (!workset)) do
	    let val {P => _} U rest = !workset
	    in
		workset := rest;
		if P inset !Psr
		    then ()
		else if P inset pr
		    then workset := !workset U
			union {{Q | ATOM (Q, _) in list body}
			      | DCLAUSE (_, _, _, body) in list ?pr P}
		else ()
	    end;
	    !Psr
    end

fun inline_predicates re =
    let val |[matches, ...]| = regexp re
    in
	fn (PROG (predsig, pr)) =>
	   let val matching = {P => clauses
			      | P => clauses in map pr
				such that matches P}
	       val nonmatching = matching <-| pr
	       val diversified = ref {}
	       val psig = ref predsig
	   in
	       inc diversify_count;
	       iterate
		 let val dcls' =
			 [let val newname = diversify_name (name, psig,
							    matching)
			      val divsf = diversify_clauses newname
			      fun newatom (ATOM (P, l)) = ATOM (newname P, l)
			  in
			      DCLAUSE (name, env, h,
				       let val body' = [newatom a | a in list body]
					   val used = matching <| {Q | ATOM (Q, _) in list body}
					   val reach = reachable_predicates (used, matching)
					   val copies = divsf (reach <| matching)
				       in
					   diversified := !diversified ++ copies;
					   body'
				       end)
			  end
			 | DCLAUSE (name, env, h, body) in list dcls]
		 in
		     diversified := !diversified ++ {P => dcls'}
		 end
	       | P => dcls in map nonmatching
	       end;
	       PROG (!psig, !diversified)
	   end
    end;
