
(*
 *	Copyright (c) 2002 by Laboratoire Spcification et Vrification (LSV),
 *	CNRS UMR 8643 & ENS Cachan.
 *	Written by Jean Goubault-Larrecq.  Not derived from licensed software.
 *
 *	Permission is granted to anyone to use this software for any
 *	purpose on any computer system, and to redistribute it freely,
 *	subject to the following restrictions:
 *
 *	1. Neither the author nor its employer is responsible for the consequences of use of
 *		this software, no matter how awful, even if they arise
 *		from defects in it.
 *
 *	2. The origin of this software must not be misrepresented, either
 *		by explicit claim or by omission.
 *
 *	3. Altered versions must be plainly marked as such, and must not
 *		be misrepresented as being the original software.
 *
 *	4. This software is restricted to non-commercial use only.  Commercial
 *		use is subject to a specific license, obtainable from LSV.
 *		This was developed as part of the EVA project; as such, access
 *		to this software by partners of the RNTL EVA Project (Trusted
 *		Logic S.A., Verimag) is defined by the intellectual property
 *		agreement signed as part of this project.
 *)

open "evaterm_h"

type eva_program = string -m> (string * eva_term) list;
type eva_knowledge = eva_term -m> eva_term;

type process = string set option (* privates *)
    * eva_program
    * eva_knowledge;

type type_env = string -m> eva_type;
type state = string

datatype principal = PRINCIPAL of string (* principal name = session concatenated with role name. *)
	 * type_env (* gives types to (at least) all variables created initially. *)
	 * state (* name of initial state *)
	 * process;

datatype test = LEAKED of eva_term
       | NOT_OWNED of eva_term * eva_term;
